local currentLag;

_G.switch = function(param, case_table)
    local case = case_table[param]
    if case then return case() end
    local def = case_table['default']
    return def and def() or nil
end

function modify(haste, lag)
	local value;
	switch(SavedConfig, { 
        [1] = function()
			value = (1.5/((100+haste)/100));
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[2] = function()
			value = (1.5/((100+haste)/100))*10;
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[3] = function()
			value = (1.5/((100+haste)/100))*100;
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[4] = function()
			value = (1.5/((100+haste)/100))+lag;
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[5] = function()
			value = lag-((1.3/((100+haste)/100))*100);
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[6] = function()
			value = lag-((1.3/((90+haste)/100))*100);
			ConsoleExec("SpellQueueWindow "..value)
		end,
		[7] = function()
			value = 200+lag+(1.5/((100+haste)/100));
			ConsoleExec("SpellQueueWindow "..value)
		end
	})
	if (ILFF:IsShown() == true) then
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
	end
end

local frame = CreateFrame("FRAME", "InputLagFix_FRAME");
frame:RegisterEvent("UNIT_SPELL_HASTE");
local function eventHandler(self, event, ...)
	local _, _, lagHome, lagWorld = GetNetStats();
	local haste = GetHaste()
	if lagHome >= lagWorld then
		currentLag = lagHome
	elseif lagWorld > lagHome then
		currentLag = lagWorld
	end
	if ((AutoMode == true) and (event == "UNIT_SPELL_HASTE")) then
		modify(haste, currentLag)
	end
end
frame:SetScript("OnEvent", eventHandler);
