local pref = "[InputLagFix] ";
local version = "5.7";
local L = ILF_Locales;

ILFF = CreateFrame("Frame", "ILFF", UIParent, "UIPanelDialogTemplate"); -- InputLagFix Frame Menu

local frame = CreateFrame("FRAME");
frame:RegisterEvent("ADDON_LOADED");
local function eventHandler(frame, event, ...)
	if (event == "ADDON_LOADED") then
		if FirstTime == nil then
			FirstTime = 1
			SavedConfig = 2
			SavedSQW = 400
			message(L.FirstTimeMSG)
			ShowMSG = true;
			AutoMode = true;
		end
		if AutoMode == false then
			ILFF.cb:SetChecked(false)
		else
			ILFF.cb:SetChecked(true)
		end
		if SavedSQW == nil then
			SavedSQW = 400
		end
		if AutoMode == nil then
			AutoMode = true
		end
		if SavedConfig == nil then
			SavedConfig = 2
		end
		if ShowMSG == nil then
			ShowMSG = true;
		end
		ConsoleExec("SpellQueueWindow "..SavedSQW)
	end
end
frame:SetScript("OnEvent", eventHandler)

-- Setting ILF Frame
ILFF:SetSize(180, 177);
ILFF:SetPoint("CENTER");

-- Title
ILFF.Title:ClearAllPoints();
ILFF.Title:SetFontObject("GameFontHighlight");
ILFF.Title:SetPoint("CENTER", ILFFTitleBG, "CENTER");
ILFF.Title:SetText("InputLagFix");

-- CheckButton
ILFF.cb = CreateFrame("CheckButton", "ILF_CheckButton", ILFF, "UICheckButtonTemplate");
ILFF.cb:SetSize(35,35)
ILFF.cb:SetPoint('TOPLEFT', ILFF, 'TOPLEFT', 10, -30)
ILFF.cb:SetScript("OnClick", 
	function()
		local checked = ILFF.cb:GetChecked();
		if checked == true then
			AutoMode = true;
		else
			AutoMode = false;
		end
	end);
ILFF.cb:Hide()

-- Text
ILFF.AutoMode_Text = ILFF:CreateFontString(nil, "ARTWORK");
ILFF.AutoMode_Text:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
ILFF.AutoMode_Text:SetPoint('TOPLEFT', ILFF, 'TOPLEFT', 43, -40)
ILFF.AutoMode_Text:SetText("AutoMode")
ILFF.Config = ILFF:CreateFontString(nil, "ARTWORK");
ILFF.Config:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
ILFF.Config:SetPoint('TOPLEFT', ILFF, 'TOPLEFT', 10, -100)
ILFF.Default_MS = ILFF:CreateFontString(nil, "ARTWORK");
ILFF.Default_MS:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
ILFF.Default_MS:SetPoint('TOPLEFT', ILFF, 'TOPLEFT', 10, -120)
ILFF.AutoMode_MS = ILFF:CreateFontString(nil, "ARTWORK");
ILFF.AutoMode_MS:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
ILFF.AutoMode_MS:SetPoint('TOPLEFT', ILFF, 'TOPLEFT', 10, -140)

-- Button
ILFF.button = CreateFrame("Button", "ILF_Button", ILFF, "UIPanelButtonTemplate")
ILFF.button:SetPoint("CENTER", ILFF, "CENTER", 0, 10)
ILFF.button:SetWidth(148)
ILFF.button:SetHeight(35)
ILFF.button:SetText(L.Setup_Button)
ILFF.button:SetScript("OnClick",
	function()
		local _, _, b_lagHome, b_lagWorld = GetNetStats()
		if b_lagHome >= b_lagWorld then
			ConsoleExec("SpellQueueWindow "..b_lagHome)
			SavedSQW = b_lagHome
		else
			ConsoleExec("SpellQueueWindow "..b_lagWorld)
			SavedSQW = b_lagWorld
		end
		ILFF.Default_MS:SetText("Default MS: |cff00c0ff"..SavedSQW.."|r")
	end);
ILFF:SetScript("OnHide", function() ILFF.cb:Hide();ILFF.button:Hide() end)
ILFF:SetScript("OnShow", function() ILFF.cb:Show();ILFF.button:Show() end)
ILFF:SetMovable(true)
ILFF:EnableMouse(true)
ILFF:RegisterForDrag("LeftButton")
ILFF:SetScript("OnDragStart", ILFF.StartMoving)
ILFF:SetScript("OnDragStop", ILFF.StopMovingOrSizing)
ILFF:Hide()

local function InputLagFix(msg, editbox)
	local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
	local _, _, lagHome, lagWorld = GetNetStats()
	local newValueConfig, ownHaste, currLag;
	if cmd == "set" and args ~= "" then
		local num = tonumber(args)
		if num == nil then
			print(pref..L.StringInsteadOfNumber)
		else
			ConsoleExec("SpellQueueWindow "..args);
			AutoMode = false;
			if (ILFF.cb:GetChecked() == true) then
				ILFF.cb:SetChecked(false)
			end
			if num < 0 then
				num = 0;
			elseif num > 400 then
				num = 400;
			end
			SavedSQW = num
			if ShowMSG == true then
				print(L.MS_Setted..num..".")
			end
			ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
			if AutoMode == true then
				print(L.AutoMode_OFF)
			end
		end
	elseif cmd == "off" then
		ShowMSG = false;
		print(pref.."Now you can use \"/ilf [n]\" in macros, without messages!")
	elseif cmd == "on" then
		ShowMSG = true;
		print(pref.."Now you can see \"/ilf [n]\" messages. Use \"/ilf off\" to deactivate it.")
	elseif cmd == "1" then
		SavedConfig = 1;
		ownHaste = GetHaste()
		newValueConfig = 1.5/((100+ownHaste)/100)
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config1)
		end
	elseif cmd == "2" then
		SavedConfig = 2;
		ownHaste  = GetHaste()
		newValueConfig = (1.5/((100+ownHaste)/100))*10
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config2)
		end
	elseif cmd == "3" then
		SavedConfig = 3;
		ownHaste = GetHaste()
		newValueConfig = (1.5/((100+ownHaste)/100))*100
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config3)
		end
	elseif cmd == "4" then
		SavedConfig = 4;
		ownHaste = GetHaste()
		if lagHome >= lagWorld then
			currLag = lagHome
		elseif lagWorld > lagHome then
			currLag = lagWorld
		end
		newValueConfig = (1.5/((100+ownHaste)/100))+currLag
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config4)
		end
	elseif cmd == "5" then
		SavedConfig = 5;
		ownHaste = GetHaste()
		if lagHome >= lagWorld then
			currLag = lagHome
		elseif lagWorld > lagHome then
			currLag = lagWorld
		end
		newValueConfig = currLag-((1.3/((100+ownHaste)/100))*100);
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config5)
		end
	elseif cmd == "6" then
		SavedConfig = 6;
		if lagHome >= lagWorld then
			currLag = lagHome
		elseif lagWorld > lagHome then
			currLag = lagWorld
		end
		newValueConfig = currLag-((1.3/((90+ownHaste)/100))*100);
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config6)
		end
	elseif cmd == "7" then
		SavedConfig = 7;
		ownHaste = GetHaste()
		if lagHome >= lagWorld then
			currLag = lagHome
		elseif lagWorld > lagHome then
			currLag = lagWorld
		end
		newValueConfig = 200+currLag+(1.5/((100+ownHaste)/100));
		ConsoleExec("SpellQueueWindow "..newValueConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		if ShowMSG == true then
			print(pref..L.Config7)
		end
	elseif cmd == "version" then
		print(pref..L.Version..version.." | by ghanvert001 ([US] Bucketthead-Illidan)")
	elseif cmd == "help" then
		print(L.Help1)
		print(L.Help2)
		print(L.Help3)
		print(L.Help4)
		print(L.Help5)
		print(L.Help6)
	else
		ILFF.Default_MS:SetText("Default MS: |cff00c0ff"..SavedSQW.."|r")
		ILFF.Config:SetText("AutoMode Config: "..SavedConfig)
		ILFF.AutoMode_MS:SetText("Current MS: |cff00c0ff"..string.format("%.2f", GetCVar("SpellQueueWindow")).."|r")
		ILFF:Show()
	end
end
SLASH_ILF1, SLASH_ILF2 = '/ilf', '/inputlagfix'
SlashCmdList["ILF"] = InputLagFix
